// Options.cpp : implementation file
//

#include "stdafx.h"
#include "simulate.h"
#include "Options.h"
#include "BrowseFileDialog.h"
#include <string.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptions dialog


COptions::COptions(CWnd* pParent /*=NULL*/)
	: CDialog(COptions::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptions)
	m_FrameAndSlot = FALSE;
	m_SrcAndDest = FALSE;
	m_CMContents = -1;
	m_OutputFileSpec = _T("");
	m_YesFile = -1;
	//}}AFX_DATA_INIT
}


void COptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptions)
	DDX_Control(pDX, IDC_FILE_SPEC, m_FileSpec);
	DDX_Check(pDX, IDC_FRAME_AND_SLOT, m_FrameAndSlot);
	DDX_Check(pDX, IDC_SRC_AND_DEST, m_SrcAndDest);
	DDX_Radio(pDX, IDC_FRAME, m_CMContents);
	DDX_Text(pDX, IDC_FILE_SPEC, m_OutputFileSpec);
	DDX_Radio(pDX, IDC_NoFile, m_YesFile);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptions, CDialog)
	//{{AFX_MSG_MAP(COptions)
	ON_BN_CLICKED(IDC_NoFile, OnNoResultsFile)
	ON_BN_CLICKED(IDC_YesFile, OnYesResultsFile)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptions message handlers
void COptions::EnableControls(BOOL flag)
{
  GetDlgItem(IDC_STATIC_CM)->EnableWindow(flag);
  GetDlgItem(IDC_FRAME)->EnableWindow(flag);
  GetDlgItem(IDC_SECOND)->EnableWindow(flag);
  GetDlgItem(IDC_MINUTE)->EnableWindow(flag);
  GetDlgItem(IDC_NEVER)->EnableWindow(flag);

  GetDlgItem(IDC_STATIC_RESULTS)->EnableWindow(flag);
  GetDlgItem(IDC_FRAME_AND_SLOT)->EnableWindow(flag);
  GetDlgItem(IDC_SRC_AND_DEST)->EnableWindow(flag);

  GetDlgItem(IDC_STATIC_PATH_AND_NAME)->EnableWindow(flag);
  GetDlgItem(IDC_FILE_SPEC)->EnableWindow(flag);
  GetDlgItem(IDC_BROWSE)->EnableWindow(flag);
}

void COptions::OnNoResultsFile() 
{
	// TODO: Add your control notification handler code here
	if ( IsDlgButtonChecked(IDC_NoFile) )
	  m_YesFile = No ;
	else
      m_YesFile = Yes ;
	EnableControls(m_YesFile);
}

void COptions::OnYesResultsFile() 
{
	// TODO: Add your control notification handler code here
    if ( IsDlgButtonChecked(IDC_YesFile) )
	  m_YesFile = Yes ;
	else
      m_YesFile = No ;
	EnableControls(m_YesFile);
}

BOOL COptions::OnInitDialog() 
{
	CDialog::OnInitDialog();	
	// TODO: Add extra initialization here
	m_YesFile = No ;
	((CButton*)GetDlgItem(IDC_NoFile))->SetCheck(1);
	m_FrameAndSlot = TRUE ;
	((CButton*)GetDlgItem(IDC_FRAME_AND_SLOT))->SetCheck(1);
	m_SrcAndDest = TRUE ;
	((CButton*)GetDlgItem(IDC_SRC_AND_DEST))->SetCheck(1);
	m_CMContents = MINUTE ;
	((CButton*)GetDlgItem(IDC_MINUTE))->SetCheck(1);

    char buffer[MAX_FILE_SPEC];
	::GetCurrentDirectory(MAX_FILE_SPEC,buffer);
	char WindowCaption[MAX_WINDOW_CAPTION];
	CMDIChildWnd* pActiveChild ;
	pActiveChild = ((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive() ;
	if ( pActiveChild == NULL )
		strcat(buffer,"\\Result.nwr") ;
	else
	 {
      pActiveChild->GetWindowText(WindowCaption,MAX_WINDOW_CAPTION);
	  strcat(buffer,"\\");
	  strcat(buffer,WindowCaption);
	  strcat(buffer,".nwr");
	 }	
	((CEdit*)GetDlgItem(IDC_FILE_SPEC))->SetWindowText(buffer);
    EnableControls(m_YesFile);		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptions::OnBrowse() 
{
	// TODO: Add your control notification handler code here
  	CBrowseFileDialog dlg(TRUE,"Result Files (*.nwr)");
	char buffer[MAX_FILE_SPEC];
	GetDlgItemText(IDC_FILE_SPEC,buffer,MAX_FILE_SPEC);
	strcpy(dlg.m_ofn.lpstrFile,buffer) ;
    dlg.m_ofn.nMaxFile = MAX_FILE_SPEC ;
	int nModal = dlg.DoModal() ;	
	if (nModal == IDOK)
	  {
		CString strFileName = dlg.GetPathName() ;
		strFileName = strFileName.SpanExcluding(".,;'");
		strFileName += ".nwr" ;
	   ((CEdit*)GetDlgItem(IDC_FILE_SPEC))->SetWindowText(strFileName);;
	  }
}
