// Parameters.cpp : implementation file
//

#include "stdafx.h"
#include "simulate.h"
#include "Parameters.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CParameters dialog


CParameters::CParameters(CWnd* pParent /*=NULL*/)
	: CDialog(CParameters::IDD, pParent)
{
	//{{AFX_DATA_INIT(CParameters)
	m_N = 0;
	m_interval = 0;
	m_T = 0;
	m_traffic = -1;
	m_pos = 0;
	m_frames = 0;
	m_topology = -1;
	m_MaxOneCallPer = 0;
	m_calls_per_minute = 0;
	//}}AFX_DATA_INIT
}


void CParameters::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CParameters)
	DDX_Control(pDX, IDC_EDIT_CALLS, m_calls_per_minute_string);
	DDX_Control(pDX, IDC_EDIT_MAX_ONE_CALL_Per, m_MaxOneCallPer_String);
	DDX_Control(pDX, IDC_EDIT_FRAMES, m_frames_string);
	DDX_Control(pDX, IDC_SPIN_INTERVAL, m_SpinValue);
	DDX_Control(pDX, IDC_EDIT_T, m_T_string);
	DDX_Control(pDX, IDC_EDIT_INTERVAL, m_interval_string);
	DDX_Control(pDX, IDC_EDIT_N, m_N_string);
	DDX_Text(pDX, IDC_EDIT_N, m_N);
	DDX_Text(pDX, IDC_EDIT_INTERVAL, m_interval);
	DDX_Text(pDX, IDC_EDIT_T, m_T);
	DDX_Scroll(pDX, IDC_SCROLLBAR_FRAMES, m_pos);
	DDX_Text(pDX, IDC_EDIT_FRAMES, m_frames);
	DDX_Radio(pDX, IDC_TS, m_topology);
	DDX_Text(pDX, IDC_EDIT_MAX_ONE_CALL_Per, m_MaxOneCallPer);
	DDX_Text(pDX, IDC_EDIT_CALLS, m_calls_per_minute);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CParameters, CDialog)
	//{{AFX_MSG_MAP(CParameters)
	ON_EN_CHANGE(IDC_EDIT_FRAMES, OnChangeEditFrames)
	ON_WM_HSCROLL()
	ON_EN_CHANGE(IDC_EDIT_CALLS, OnChangeEditCalls)
	ON_EN_CHANGE(IDC_EDIT_N, OnChangeEditN)
	ON_EN_CHANGE(IDC_EDIT_T, OnChangeEditT)
	ON_EN_CHANGE(IDC_EDIT_MAX_ONE_CALL_Per, OnChangeEditMaxOneCallPer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CParameters message handlers

BOOL CParameters::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_N_string.LimitText(3);
	m_T_string.LimitText(3);
	m_interval_string.LimitText(2);
	m_MaxOneCallPer_String.LimitText(3);
	m_frames_string.LimitText(4) ;
	m_calls_per_minute_string.LimitText(4);

    CSpinButtonCtrl* SBtnTemp ;
	SBtnTemp = (CSpinButtonCtrl *) GetDlgItem(IDC_SPIN_INTERVAL) ;
	SBtnTemp->SetBuddy(GetDlgItem(IDC_EDIT_INTERVAL));   
    SBtnTemp->SetRange(min_interval,max_interval);

	SBtnTemp = (CSpinButtonCtrl *) GetDlgItem(IDC_SPIN_MAX_ONE_CALL_PER) ;
	SBtnTemp->SetBuddy(GetDlgItem(IDC_EDIT_MAX_ONE_CALL_Per));   
    SBtnTemp->SetRange(min_subscriber_rate,max_subscriber_rate);
	 
	CScrollBar* HScrlTemp = (CScrollBar *) GetDlgItem(IDC_SCROLLBAR_FRAMES);
	HScrlTemp->SetScrollRange(min_ave_duration,max_ave_duration);
    HScrlTemp->SetScrollPos(m_frames);

    SetMaximumLambda() ;
	SetDlgItemInt(IDC_EDIT_CALLS,m_calls_per_minute);
	HScrlTemp->SetScrollPos(m_calls_per_minute);
	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CParameters::SetMaximumLambda()
{
	int TempMaxLambda = (int)GetDlgItemInt(IDC_EDIT_N)*GetDlgItemInt(IDC_EDIT_T)/max(GetDlgItemInt(IDC_EDIT_MAX_ONE_CALL_Per),min_subscriber_rate) + 1 ;
	max_arrival_rate=max(TempMaxLambda,2) ;
	
    CScrollBar* HScrlTemp = (CScrollBar *) GetDlgItem(IDC_SCROLLBAR_CALLS);
	HScrlTemp->SetScrollRange(min_arrival_rate,max_arrival_rate);
    HScrlTemp->SetScrollPos(min_arrival_rate);
	SetDlgItemInt(IDC_EDIT_CALLS,min_arrival_rate);
}

void CParameters::OnOK() 
{
	// TODO: Add extra validation here
    
    CString msg ;
	
	int temp ;
	temp = GetDlgItemInt(IDC_EDIT_N) ;
    if ( (temp<min_N) || (temp>max_N) )
	{   
	  msg.Format("%s %d %s %d" , (LPCTSTR)"Please, Enter a value for N between " , min_N , (LPCTSTR)" and " , max_N ) ;
	  MessageBox(msg,"Value out of range",MB_OK|MB_ICONSTOP);
    } // end if 
	else
	{
      temp = GetDlgItemInt(IDC_EDIT_T) ;
      if ( (temp<min_T) || (temp>max_T) )
	  {   
	  msg.Format("%s %d %s %d" , (LPCTSTR)"Please, Enter a value for T between " , min_T , (LPCTSTR)" and " , max_T ) ;
	  MessageBox(msg,"Value out of range",MB_OK|MB_ICONSTOP);
      }
	  else
	  {
		temp = GetDlgItemInt(IDC_EDIT_FRAMES);
		if ( (temp<min_ave_duration) || (temp>max_ave_duration) )
	    {   
	      msg.Format("%s %d %s %d" , (LPCTSTR)"Please, Enter a value for the average duration of a call between " , min_ave_duration , (LPCTSTR)" and " , max_ave_duration ) ;
	      MessageBox(msg,"Value out of range",MB_OK|MB_ICONSTOP);
        }
		else
		{
		  temp = GetDlgItemInt(IDC_EDIT_CALLS);
		  if ( (temp<min_arrival_rate) || (temp>max_arrival_rate) )
	      {   
	       msg.Format("%s %d %s %d" , (LPCTSTR)"Please, Enter a value for the average arrival rate between " , min_arrival_rate , (LPCTSTR)" and " , max_arrival_rate ) ;
	       MessageBox(msg,"Value out of range",MB_OK|MB_ICONSTOP);
          }
		  else
		  {
            temp = GetDlgItemInt(IDC_EDIT_INTERVAL) ;
            if ( (temp<min_interval) || (temp>max_interval) )
	        {   
	          msg.Format("%s %d %s %d" , (LPCTSTR)"Please, Enter a value for the simulation interval between " , min_interval , (LPCTSTR)" and " , max_interval ) ;
	          MessageBox(msg,"Value out of range",MB_OK|MB_ICONSTOP); 
            }
			else
		    {
              temp = GetDlgItemInt(IDC_EDIT_MAX_ONE_CALL_Per) ;
              if ( (temp<min_subscriber_rate) || (temp>max_subscriber_rate) )
	          {   
	            msg.Format("%s %d %s %d" , (LPCTSTR)"Please, Enter a value for the maximum number of calls made by a subscriber in the range from " , min_subscriber_rate , (LPCTSTR)" to " , max_subscriber_rate ) ;
	            MessageBox(msg,"Value out of range",MB_OK|MB_ICONSTOP); 
              }
		      else CDialog::OnOK();   // sixth else
            }//end fifth else
          }//end fourth else
		}//end third else
	  }// end second else	  
    }//end first else
}// end function

void CParameters::OnChangeEditFrames() 
{
	// TODO: Add your control notification handler code here
	CScrollBar* HScrlTemp = (CScrollBar *) GetDlgItem(IDC_SCROLLBAR_FRAMES);    	
	HScrlTemp->SetScrollPos(GetDlgItemInt(IDC_EDIT_FRAMES));
}

void CParameters::OnChangeEditCalls() 
{
	// TODO: Add your control notification handler code here
	CScrollBar* HScrlTemp = (CScrollBar *) GetDlgItem(IDC_SCROLLBAR_CALLS);    	
	HScrlTemp->SetScrollPos(GetDlgItemInt(IDC_EDIT_CALLS));
}

void CParameters::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
 if (pScrollBar==(CScrollBar *)GetDlgItem(IDC_SCROLLBAR_FRAMES))
   switch ( nSBCode )
	{
	case SB_LINELEFT :
        SetDlgItemInt(IDC_EDIT_FRAMES,max(min_ave_duration,pScrollBar->GetScrollPos()-1));break ;
	case SB_LINERIGHT :
		SetDlgItemInt(IDC_EDIT_FRAMES,min(max_ave_duration,pScrollBar->GetScrollPos()+1));break ;
	case SB_PAGELEFT :
        SetDlgItemInt(IDC_EDIT_FRAMES,max(min_ave_duration,pScrollBar->GetScrollPos()-100));break ;
	case SB_PAGERIGHT :
		SetDlgItemInt(IDC_EDIT_FRAMES,min(max_ave_duration,pScrollBar->GetScrollPos()+100));break ;
    case SB_LEFT :
        SetDlgItemInt(IDC_EDIT_FRAMES,min_ave_duration);break ;
	case SB_RIGHT :
		SetDlgItemInt(IDC_EDIT_FRAMES,max_ave_duration);break ;
    case SB_THUMBTRACK :
	case SB_THUMBPOSITION :
        SetDlgItemInt(IDC_EDIT_FRAMES,nPos);break ;
	}
else 
 if (pScrollBar==(CScrollBar *)GetDlgItem(IDC_SCROLLBAR_CALLS))
   switch ( nSBCode )
	{
	case SB_LINELEFT :
        SetDlgItemInt(IDC_EDIT_CALLS,max(min_arrival_rate,pScrollBar->GetScrollPos()-1));break ;
	case SB_LINERIGHT :
		SetDlgItemInt(IDC_EDIT_CALLS,min(max_arrival_rate,pScrollBar->GetScrollPos()+1));break ;
	case SB_PAGELEFT :
        SetDlgItemInt(IDC_EDIT_CALLS,max(min_arrival_rate,pScrollBar->GetScrollPos()-10));break ;
	case SB_PAGERIGHT :
		SetDlgItemInt(IDC_EDIT_CALLS,min(max_arrival_rate,pScrollBar->GetScrollPos()+10));break ;
    case SB_LEFT :
        SetDlgItemInt(IDC_EDIT_CALLS,min_arrival_rate);break ;
	case SB_RIGHT :
		SetDlgItemInt(IDC_EDIT_CALLS,max_arrival_rate);break ;
    case SB_THUMBTRACK :
	case SB_THUMBPOSITION :
        SetDlgItemInt(IDC_EDIT_CALLS,nPos);break ;
	}
  	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CParameters::OnChangeEditN() 
{
	// TODO: Add your control notification handler code here
    SetMaximumLambda();	
}

void CParameters::OnChangeEditT() 
{
	// TODO: Add your control notification handler code here
	SetMaximumLambda();
}

void CParameters::OnChangeEditMaxOneCallPer() 
{
	// TODO: Add your control notification handler code here
	SetMaximumLambda();
}
