// simulateView.cpp : implementation of the CSimulateView class
//
#include <afxext.h>

#include "stdafx.h"
#include "simulate.h"
#include "mainfrm.h"
#include "math.h"
#include "simulateView.h"
#include "ResultsView.h"

#include "Options.h"

#include <stdio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Implementation of the TST classes

CTimeSwitching::CTimeSwitching(int T)
{
m_control_array=(int *)new int [T];
for (int i=0;i<T;i++)
	m_control_array[i]=NOT_USED;
}



void CSimulateView::DrawMUX(int x,int y)
{
	CClientDC ClientDC(this);
	CClientDC *pDC;
	pDC=&ClientDC;
	OnPrepareDC(pDC);
	CPen Pen;
	CPen *pOldPen;
	Pen.CreatePen(PS_SOLID,3,RGB(0,0,0));
	pOldPen=pDC->SelectObject(&Pen);
	LINE(x,y,x,y+GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT);
	LINE(x,y,x+50,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0);
	LINE(x+50,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0,x,y+GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT);
	pDC->SelectObject(pOldPen);
	for(int i=0;i<GetDocument()->GetT();i++)
		LINE(x-20,y+i*GR_SLOT_HEIGHT+GR_SLOT_HEIGHT*.5,x,y+i*GR_SLOT_HEIGHT+GR_SLOT_HEIGHT*.5);
	


	switch(GetDocument()->GetTopology())
	{
	case TST:
	case TS:
		LINE(x+50,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0,175,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0);
		break;
	case ST:																	
		LINE(x+50,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0,275,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0);
		break;
	}

	/*pDC->SelectStockObject(LTGRAY_BRUSH);
	//pDC->FloodFill(x+40,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0,RGB(0,0,0));
	pDC->FloodFill(x+3,y+10,RGB(0,0,0));
	pDC->FloodFill(x+3,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)-10,RGB(0,0,0));*/


}

void CSimulateView::DrawDEMUX(int x,int y)
{

	CClientDC ClientDC(this);
	CClientDC *pDC;
	pDC=&ClientDC;
	OnPrepareDC(pDC);
	CPen Pen;
	CPen *pOldPen;
	Pen.CreatePen(PS_SOLID,3,RGB(0,0,0));
	pOldPen=pDC->SelectObject(&Pen);
	LINE(x,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0,x+50,y);
	LINE(x,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0,x+50,y+GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT);
	LINE(x+50,y,x+50,y+GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT);
	pDC->SelectObject(pOldPen);
	for(int i=0;i<GetDocument()->GetT();i++)
		LINE(x+50,y+i*GR_SLOT_HEIGHT+GR_SLOT_HEIGHT*.5,x+70,y+i*GR_SLOT_HEIGHT+GR_SLOT_HEIGHT*.5);
	

	switch(GetDocument()->GetTopology())
	{
	case TST:
	case ST:
		LINE(x,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0,475,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0);
		break;
	case TS:																	
		LINE(x,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0,375,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0);
		break;
	}


}


void CSimulateView::UpdateTimeElementForAllViews(int x,int y,int col,int line,int elementno)
{
	POSITION pos = GetDocument()->GetFirstViewPosition();
   while (pos != NULL)
   {
	CView* pView = GetDocument()->GetNextView(pos);
	CClientDC ClientDC(pView);
	CDC *pDC;
	pDC=&ClientDC;
	pView->OnPrepareDC(pDC);
	UpdateTimeElement(x,y,col,line,elementno,pDC);
   }

}

void CSimulateView::UpdateGSElementForAllViews(int x,int y,int input,int slot)
{
	CClientDC ClientDC(this);
	CDC *pDC;
	pDC=&ClientDC;
	OnPrepareDC(pDC);
	UpdateGSElement(x,y,input,slot,pDC);

	/*POSITION pos = GetDocument()->GetFirstViewPosition();
   while (pos != NULL)
   {
	CView* pView = GetDocument()->GetNextView(pos);
	CClientDC ClientDC(pView);
	CDC *pDC;
	pDC=&ClientDC;
	pView->OnPrepareDC(pDC);
	UpdateGSElement(x,y,input,slot,pDC);
   }*/
}


void CSimulateView::DrawGS(int x,int y)
{
	int N=GetDocument()->GetN();
	int T=GetDocument()->GetT();

	CClientDC ClientDC(this);
	CClientDC *pDC;
	pDC=&ClientDC;
	OnPrepareDC(pDC);
	
	for(int i=0;i<N;i++)
		for(int j=0;j<T;j++)
	 		UpdateGSElementForAllViews(x,y,i,j);

	for (i=0;i<N;i++)
	{
	int px=x+i*GR_SLOT_WIDTH;
	char buf1[4];
	int len1;
		sprintf(buf1,"%i",i);
		if(i<10) len1=1;
		else len1=2;
		if(m_ZoomingRatio>=1)
		pDC->TextOut((px+4)*m_ZoomingRatio,(y-20)*m_ZoomingRatio,buf1,len1);
	}

	for (i=0;i<T;i++)
	{
	int py=y+i*GR_SLOT_HEIGHT*2;
	char buf1[4];
	int len1;
		sprintf(buf1,"%i",i);
		if(i<10) len1=1;
		else len1=2;
		if(m_ZoomingRatio>=1)
		pDC->TextOut((x-20)*m_ZoomingRatio,(py+4)*m_ZoomingRatio,buf1,len1);
	}
}



void CSimulateView::UpdateGSElement(int x,int y,int input,int slot,CDC *pDC)
{
	char buf1[6];
	char buf2[6];
	for(int i=0;i<6;i++)
		buf2[i]=buf1[i]=' ';
	int len1,len2;

	int px=x+input*GR_SLOT_WIDTH;
	int py=y+slot*GR_SLOT_HEIGHT*2;

	if(m_SimulationStatus != NotSimulating)
	switch(GetDocument()->GetTopology())
	{
	case TST:
		sprintf(buf1,"%i",m_S->m_gate_select_memory[input][slot].outlet);
		len1=(int)log(m_S->m_gate_select_memory[input][slot].outlet);
		/*if (m_S->m_gate_select_memory[input][slot].outlet<10) 
			len1=1;
		if (m_S->m_gate_select_memory[input][slot].outlet>=10) 
			len1=2; 
		if (m_S->m_gate_select_memory[input][slot].outlet>=100)
			len1=3;*/
		sprintf(buf2,"%i",m_S->m_gate_select_memory[input][slot].duration);
		len2=(int)log(m_S->m_gate_select_memory[input][slot].duration);
		/*if (m_S->m_gate_select_memory[input][slot].duration<10) 
			len2=1;
		if (m_S->m_gate_select_memory[input][slot].duration>=10) 
			len2=2;
		if (m_S->m_gate_select_memory[input][slot].duration>=100)
			len2=3;*/
		break;
	case ST:
		sprintf(buf1,"%i",m_StGateSelect->GetOutlet(slot,input));
		len1=(int)log(m_StGateSelect->GetOutlet(slot,input));
/*		if (m_StGateSelect->GetOutlet(slot,input)<10) 
			len1=1;
		if (m_StGateSelect->GetOutlet(slot,input)>=10) 
			len1=2;
		if (m_StGateSelect->GetOutlet(slot,input)>=100)
			len1=3;*/
		sprintf(buf2,"%i",m_StGateSelect->GetDuration(slot,input));
		len2=(int)log(m_StGateSelect->GetDuration(slot,input));
		/*if (m_StGateSelect->GetDuration(slot,input)<10) 
			len2=1;
		if (m_StGateSelect->GetDuration(slot,input)>=10) 
			len2=2;
		if (m_StGateSelect->GetDuration(slot,input)>=100)
			len2=3;*/
		break;
	case TS:
		sprintf(buf1,"%i",m_TsGateSelect->GetOutlet(slot,input));
		len1=(int)log(m_TsGateSelect->GetOutlet(slot,input))+1;
		/*if (m_TsGateSelect->GetOutlet(slot,input)<10) 
			len1=1;
		if (m_TsGateSelect->GetOutlet(slot,input)>=10) 
			len1=2;
		if (m_TsGateSelect->GetOutlet(slot,input)>=100)
			len1=3;*/
		sprintf(buf2,"%i",m_TsGateSelect->GetDuration(slot,input));
		len2=(int)log(m_TsGateSelect->GetOutlet(slot,input))+1;
		/*if (m_TsGateSelect->GetDuration(slot,input)<10) 
			len2=1;
		if (m_TsGateSelect->GetDuration(slot,input)>=10) 
			len2=2;
		if (m_TsGateSelect->GetDuration(slot,input)>=100)
			len2=3;*/
		break;
	}

	CPen Pen;
	CPen *pOldPen;
	Pen.CreatePen(PS_SOLID,3,RGB(0,0,0));
	pOldPen=pDC->SelectObject(&Pen);
	RECTANGLE(px,py,px+GR_SLOT_WIDTH,py+GR_SLOT_HEIGHT*2);
	pDC->SelectObject(pOldPen);
	RECTANGLE(px,py,px+GR_SLOT_WIDTH,py+GR_SLOT_HEIGHT);
	
	for(i=0;i<6;i++)
	{
		if ((buf2[i]>'9' || buf2[i]<'0') && buf2[i]!='-') buf2[i]=' ';
		if ((buf1[i]>'9' || buf1[i]<'0') && buf1[i]!='-') buf1[i]=' ';
	}
	if(m_ZoomingRatio>=1)
	{
	pDC->TextOut((px+4)*m_ZoomingRatio,(py+2)*m_ZoomingRatio,"            ",6);
	pDC->TextOut((px+4)*m_ZoomingRatio,(py+2+GR_SLOT_HEIGHT)*m_ZoomingRatio,"            ",6);
	
	pDC->TextOut((px+4)*m_ZoomingRatio,(py+2)*m_ZoomingRatio,buf1,6);
	pDC->TextOut((px+4)*m_ZoomingRatio,(py+2+GR_SLOT_HEIGHT)*m_ZoomingRatio,buf2,6);
	}
}





void CSimulateView::UpdateTimeElement(int x,int y,int col,int line,int elementno,CDC *pDC)
{
	char buf[5];
	if(m_SimulationStatus != NotSimulating)
	switch(GetDocument()->GetTopology())
	{
	case TST:
		sprintf(buf,"%i2",m_T[col][line]->m_control_array[elementno]);
		break;
	case ST:		
		sprintf(buf,"%i2",m_StTsi[line]->GetValue(elementno));
		break;
	case TS:
		sprintf(buf,"%i2",m_TsTsi[line]->GetValue(elementno));
		break;
	}
	else 
		sprintf(buf,"%i2",-1);

	int len=1;
	if (GetDocument()->GetT()>=10) len=2;
	if(m_ZoomingRatio>=1)
		pDC->TextOut((x+20)*m_ZoomingRatio,(y+elementno*GR_SLOT_HEIGHT+1)*m_ZoomingRatio,"    ",4); 
	
	if(m_ZoomingRatio>=1)
		pDC->TextOut((x+20)*m_ZoomingRatio,(y+elementno*GR_SLOT_HEIGHT+1)*m_ZoomingRatio,buf,len);
	RECTANGLE(x,y+elementno*GR_SLOT_HEIGHT,x+50,y+GR_SLOT_HEIGHT+elementno*GR_SLOT_HEIGHT);

	int T=GetDocument()->GetT();
	CPen Pen;
	CPen *pOldPen;
	Pen.CreatePen(PS_SOLID,3,RGB(0,0,0));
	pOldPen=pDC->SelectObject(&Pen);
	RECTANGLE(x,y,x+50,y+GR_SLOT_HEIGHT+(T-1)*GR_SLOT_HEIGHT);
	pDC->SelectObject(pOldPen);
}


void CSimulateView::DrawTime(int x,int y,int col,int line)
{
		CClientDC ClientDC(this);
	CClientDC *pDC;
	pDC=&ClientDC;
	OnPrepareDC(pDC);

	int T=GetDocument()->GetT();
	for(int i=0;i<T;i++)
		UpdateTimeElement(x,y,col,line,i,pDC);
		CPen Pen;
	CPen *pOldPen;
	Pen.CreatePen(PS_SOLID,3,RGB(0,0,0));
	pOldPen=pDC->SelectObject(&Pen);
	RECTANGLE(x,y,x+50,y+GR_SLOT_HEIGHT+(T-1)*GR_SLOT_HEIGHT);
	pDC->SelectObject(pOldPen);
	switch(GetDocument()->GetTopology())
	{
	case TST:
	case ST:
		if(col==1)
			LINE(x,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0,375,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0);
		else
			LINE(x+50,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0,275,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0);
		break;
	case TS:
		if(col==1)
			LINE(x,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0,375,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0);
		else
			LINE(x+50,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0,275,y+(GR_SLOT_HEIGHT+(GetDocument()->GetT()-1)*GR_SLOT_HEIGHT)/2.0);
		break;
		break;
	}

	
}

void CSimulateView::DrawSpace(int x,int y)
{
	int N=GetDocument()->GetN();
	int T=GetDocument()->GetT();
	CClientDC ClientDC(this);
	CClientDC *pDC;
	pDC=&ClientDC;
	OnPrepareDC(pDC);


	RECTANGLE(x,y,x+100,y+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*N);
}


CTimeSwitching::~CTimeSwitching()
{
delete m_control_array;
}

CSpace::CSpace(int N,int M)
{
m_M=M;
m_N=N;
m_gate_select_memory=(struct Call **)new  struct Call * [N];    	// 012345....N
for(int i=0;i<N;i++)                            	// 1  X	  X=[3,1].outlet
	{                                               // 2       @slot 1
	m_gate_select_memory[i]=new struct Call[M];     // 3.....   connect
	for (int j=0;j<M;j++)                           // .	    INLET 3
	{
		m_gate_select_memory[i][j].outlet=NOT_USED;	// T	    to INLET x
		m_gate_select_memory[i][j].duration=0;
	}
	}												//    X[3,1].duration=
}													//     time left for the call
													//		to end
CSpace::~CSpace()
{
for(int i=0;i<m_N;i++)
	delete m_gate_select_memory[i];
delete m_gate_select_memory;
}


// Borrowed from Sobeih!
int CSpace::CheckDuplicateTransmitter(int Line,int Slot)
{
	if ( m_gate_select_memory[Line][Slot].outlet != NOT_USED )
		 return 1  ;
	else
		 return 0  ;
}


// Implementation of the TST classes ended!

/////////////////////////////////////////////////////////////////////////////
// Implementation of the Time Slot Interchanger class
// CST_TSI
CST_TSI::CST_TSI(int T)
{
	m_Size = T ;
	to = new int [T];
	for(int i=0 ; i<T ; i++)
		to[i] = NOT_USED ;
}

void CST_TSI::SetValue(int index,int value)
{ to[index] = value ; }

int CST_TSI::GetValue(int index)
{ return to[index] ; }

int CST_TSI::CheckBusyReceiver(int key)
{
  int i=0 ;
  while (i<m_Size)
	  if (to[i++] == key)
	     return 1 ;
  return 0 ;
}

CST_TSI::~CST_TSI()
{
	delete[m_Size] to ;
}
/////////////////////////////////////////////////////////////////////////////
// Implementation of the Space Array Control Class
// CST_GateSelect
CST_GateSelect::CST_GateSelect(int T , int N) 
{
   m_Slots = T ; m_Lines = N ;   
   memory = new ST_Call* [m_Slots] ;
   for (int i=0;i<m_Slots;i++)
	  {
	   memory[i] = new ST_Call [m_Lines];
	   for (int j=0;j<m_Lines;j++)
	   {
		   memory[i][j].outlet = NOT_USED ;
		   memory[i][j].duration = 0 ;
	   }
      }
}

void CST_GateSelect::SetOutlet(int row,int column,int out)
{ memory[row][column].outlet = out ;  }

int  CST_GateSelect::GetOutlet(int row,int column)
{ return memory[row][column].outlet ; }

void CST_GateSelect::SetDuration(int row,int column,unsigned long hold_time)
{ memory[row][column].duration = hold_time ; } 

unsigned long CST_GateSelect::GetDuration(int row,int column)
{ return memory[row][column].duration ; }

int CST_GateSelect::CheckDuplicateTransmitter(int Line,int Slot)
{
	if ( memory[Slot][Line].outlet != NOT_USED )
		 return 1  ;
	else
		 return 0  ;
}

CST_GateSelect::~CST_GateSelect()
{
  for(int i=0 ; i<m_Slots ; i++)
	  delete [m_Lines] memory[i] ;
  delete [m_Slots] memory ;
}
/////////////////////////////////////////////////////////////////////////////
// Implementation of the Time Slot Interchanger class
// CTS_TSI
CTS_TSI::CTS_TSI(int T)
{
	m_Size = T ;
	to = new int [T];
	for(int i=0 ; i<T ; i++)
		to[i] = NOT_USED ;
}

void CTS_TSI::SetValue(int index,int value)
{ to[index] = value ; }

int CTS_TSI::GetValue(int index)
{ return to[index] ; }

int CTS_TSI::CheckDuplicateTransmitter(int key)
{
  int i=0 ;
  while (i<m_Size)
	  if (to[i++] == key)
	     return 1 ;
  return 0 ;
}

CTS_TSI::~CTS_TSI()
{
	delete[m_Size] to ;
}
/////////////////////////////////////////////////////////////////////////////
// Implementation of the Space Array Control Class
// CTS_GateSelect
CTS_GateSelect::CTS_GateSelect(int T , int N) 
{
   m_Slots = T ; m_Lines = N ;   
   memory = new ST_Call* [m_Slots] ;
   for (int i=0;i<m_Slots;i++)
	  {
	   memory[i] = new ST_Call [m_Lines];
	   for (int j=0;j<m_Lines;j++)
	   {
		   memory[i][j].outlet = NOT_USED ;
		   memory[i][j].duration = 0 ;
	   }
      }
}

void CTS_GateSelect::SetOutlet(int row,int column,int out)
{ memory[row][column].outlet = out ;  }

int  CTS_GateSelect::GetOutlet(int row,int column)
{ return memory[row][column].outlet ; }

void CTS_GateSelect::SetDuration(int row,int column,unsigned long hold_time)
{ memory[row][column].duration = hold_time ; } 

unsigned long CTS_GateSelect::GetDuration(int row,int column)
{ return memory[row][column].duration ; }

int CTS_GateSelect::CheckBusyReceiver(int Line,int Slot)
{
	if ( memory[Slot][Line].outlet != NOT_USED )
		 return 1  ;
	else
		 return 0  ;
}

CTS_GateSelect::~CTS_GateSelect()
{
  for(int i=0 ; i<m_Slots ; i++)
	  delete [m_Lines] memory[i] ;
  delete [m_Slots] memory ;
}
////////////////////////////////////////////////////////////////////////////////////
// CSimulateView

IMPLEMENT_DYNCREATE(CSimulateView, CScrollView)

BEGIN_MESSAGE_MAP(CSimulateView, CScrollView)
	//{{AFX_MSG_MAP(CSimulateView)
	ON_COMMAND(ID_VIEW_ZOOM_IN, OnViewZoomIn)
	ON_COMMAND(ID_VIEW_ZOOM_OUT, OnViewZoomOut)
	ON_COMMAND(ID_SIMULATE_CONTINUE, OnSimulateContinue)
	ON_COMMAND(ID_SIMULATE_PAUSE, OnSimulatePause)
	ON_COMMAND(ID_SIMULATE_START, OnSimulateStart)
	ON_COMMAND(ID_SIMULATE_STEP, OnSimulateStep)
	ON_COMMAND(ID_SIMULATE_STOP, OnSimulateStop)
	ON_UPDATE_COMMAND_UI(ID_SIMULATE_CONTINUE, OnUpdateSimulateContinue)
	ON_UPDATE_COMMAND_UI(ID_SIMULATE_PAUSE, OnUpdateSimulatePause)
	ON_UPDATE_COMMAND_UI(ID_SIMULATE_START, OnUpdateSimulateStart)
	ON_UPDATE_COMMAND_UI(ID_SIMULATE_STEP, OnUpdateSimulateStep)
	ON_UPDATE_COMMAND_UI(ID_SIMULATE_STOP, OnUpdateSimulateStop)
	ON_WM_SIZE()
	ON_COMMAND(ID_SIMULATE_OPTIONS, OnSimulateResultsOptions)
	ON_UPDATE_COMMAND_UI(ID_SIMULATE_OPTIONS, OnUpdateSimulateResultsOptions)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimulateView construction/destruction

CSimulateView::CSimulateView()
{
	// TODO: add construction code here
	
	// Initially , No scroll bars are needed
	m_DrawingSize.cx = 0 ;
	m_DrawingSize.cy = 0 ;
    //SetScrollSizes(MM_TEXT,m_DrawingSize);
    // Set step size to 0
	m_xZoomStep = m_yZoomStep = 0 ;	

	m_SimulationStatus = NotSimulating ;
	m_StTsi = (CST_TSI**)NULL ;
	m_StGateSelect = (CST_GateSelect*)NULL ;
	m_TsTsi = (CTS_TSI**)NULL ;
	m_TsGateSelect = (CTS_GateSelect*)NULL ;

	m_CurrentSlot = 0 ;
	m_CurrentFrame = 0 ;
	m_CallCount = 0 ;
	m_CurrentCall = CConnection() ;
	m_MoreCalls = 1 ;
	m_NewCall = 0 ;
	m_ValidCall = 0 ;
	m_pWinThread = 0 ;
	m_Threading = 0 ;
	
	m_BlockNum = 0 ;

    m_YesFile = No ;
	strcpy(m_OutputFileSpec,"");
	m_pFile = new CStdioFile() ;
	m_FrameAndSlot = FALSE ;
	m_SrcAndDest = FALSE ;
	m_CMContents = NEVER ;
	m_ZoomingRatio=1.0;
}

CSimulateView::~CSimulateView()
{
// REDA ******************************************************************
// Add any required memmory DEallocations here .
// Memory Allocations are made just before the very beginning of simulation
// Memory DEallocations are GENERALLY made at the end of simulation , BUT
// What if the user closes the view while simulation ( or even Pause ) 
// is in progress
   switch(GetDocument()->GetTopology())
   {
   case TS  : 
	   if (   (m_SimulationStatus==Simulating)
		||    (m_SimulationStatus==Pause)      )
	   {
//		   delete m_pWinThread ;
		   TS_EndSimulation();		
	   }	   
	   break ;
   case TST : 
		    /*int i,j;
			for(i=0;i<2;i++)
			{
			for (j=0;j<m_S->m_N;j++)
				delete m_T[i][j];
			delete m_T[i];
			}
			delete m_S;*/

	   if (   (m_SimulationStatus==Simulating)
		||    (m_SimulationStatus==Pause)      )
		   TST_EndSimulation();		


			break ;
   case ST  :
	   if (   (m_SimulationStatus==Simulating)
		||    (m_SimulationStatus==Pause)      )
	   {
//		   delete m_pWinThread ;
		   ST_EndSimulation();		
	   }
	   break ;
   default  : break ;
   }  
   delete m_pFile ;
}

BOOL CSimulateView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
    
	return CScrollView::PreCreateWindow(cs);
}


CRect CSimulateView::GetDimRectangle(long left,long top,long right,long bottom) 
{
	return CRect
		( min(left,right) ,
		  min(top,bottom) ,
		  max(left,right) + 1 ,
		  max(top,bottom) + 1 ) ;
}

void CSimulateView::DrawLine(CDC* pDC , int x1, int y1 , int x2 , int y2 ) 
{
	pDC->MoveTo(x1,y1);
	pDC->LineTo(x2,y2);
}

/////////////////////////////////////////////////////////////////////////////
// CSimulateView drawing
void CSimulateView::OnDraw(CDC* pDC)
{
	CSimulateDoc* pDoc = GetDocument();

	ASSERT_VALID(pDoc);
	int N=GetDocument()->GetN();
	int T=GetDocument()->GetT();


	m_DrawingSize.cx=GR_LEFT+N*GR_SLOT_WIDTH+30;
	if(m_DrawingSize.cx<640)
		m_DrawingSize.cx=640;
	
	m_DrawingSize.cy=GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*N+
		N*GR_SLOT_HEIGHT*2+60;

	m_DrawingSize.cx*=m_ZoomingRatio;
	m_DrawingSize.cy*=m_ZoomingRatio;
	
	SetScrollSizes(MM_TEXT,m_DrawingSize);

	

	
	// TODO: add draw code for native data here
	int offset = 10 ;

	CSize size = GetTotalSize() ;
	CRect ScrollRect(0,0,size.cx,size.cy);
    pDC->LPtoDP(&ScrollRect); // change to device coordinates
	                          // so as to compare with client area dimensions
	CRect ClientArea ;
	GetClientRect(&ClientArea);
	// If the drawing area is smaller than or equal to the drawing area ,
	// Draw relative to the client area
	// else , Draw relative to the drawing area
	if ( (ScrollRect.right<=ClientArea.right) && (ScrollRect.bottom<=ClientArea.bottom) )
	{ ScrollRect.right = ClientArea .right ;
	  ScrollRect.bottom = ClientArea.bottom ;
	}	
	pDC->DPtoLP(&ScrollRect); // convert back to logical coordinates
	                          // so as to be used in drawing functions
//							  */
// REDA *******************************************************************
// For REDA : Start drawing functions here , relative to ScrollRect
//if (m_SimulationStatus != NotSimulating)
				int i,j;
	switch ( pDoc->GetTopology() )
	{
	case TS   : 
				for (j=0;j<N;j++)
					{
					DrawMUX(50,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*j);
					DrawDEMUX(525,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*j);
					DrawTime(175,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*j,0,j);
					}
			DrawSpace(275,GR_UPPER);
			break ;
	case TST  : 
			for(i=0;i<2;i++)
				{
				for (j=0;j<N;j++)
					{
					DrawMUX(50,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*j);
					DrawDEMUX(525,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*j);
					if (i==0) 
						DrawTime(175,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*j,i,j);
					else
						DrawTime(425,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*j,i,j);
					}
				}
			DrawSpace(275,GR_UPPER);
				break ;
	case ST   :	
				for (j=0;j<N;j++)
					{
					DrawMUX(50,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*j);
					DrawDEMUX(525,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*j);
					DrawTime(425,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*j,1,j);
					}
				DrawSpace(275,GR_UPPER);
		break ;
	default : break ;
	}
DrawGS(25,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*N+60);

	// End of drawing functions
}

void CSimulateView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CRect ClientArea ;
	GetClientRect(&ClientArea);

	CClientDC ClientDC(this);
	OnPrepareDC(&ClientDC);
	ClientDC.DPtoLP(&ClientArea); //Change client area dimensions to logical coordinates

	SIZE DrawingSize = {ClientArea.right,ClientArea.bottom} ;
	// Set the scroll bar sizes to the client area size
	// Hence , initially No scroll bars exist
	SetScrollSizes(MM_TEXT,DrawingSize); 
	
//	SIZE s;
//	s.cx=500;
//	s.cy=1000;
//	SetScrollSizes(MM_TEXT,s); 	
	// TODO: calculate the total size of this view
/*	CRect ClientArea;
	GetClientRect(&ClientArea);

	CClientDC ClientDC(this);
	OnPrepareDC(&ClientDC);
	ClientDC.DPtoLP(&ClientArea); //Change client area dimensions to logical coordinates
	
	m_DrawingSize.cx = ClientArea.right ;
	m_DrawingSize.cy = ClientArea.bottom ;
	// Set the scroll bar sizes to the client area size
	// Hence , initially No scroll bars exist
	SetScrollSizes(MM_TEXT,m_DrawingSize); 
	                                          
	m_xZoomStep = m_DrawingSize.cx / 10 ;
	m_yZoomStep = m_DrawingSize.cy / 10 ;*/
}

void CSimulateView::LineWRTRect(int x1,int y1,int x2,int y2,CDC *pDC)
{
	pDC->MoveTo(x1*(float)m_ZoomingRatio,y1*(float)m_ZoomingRatio);
	pDC->LineTo(x2*(float)m_ZoomingRatio,y2*(float)m_ZoomingRatio);
}

void CSimulateView::RectangleWRTRect(int x1,int y1,int x2,int y2,CDC *pDC)
{
	LineWRTRect(x1,y1,x2,y1,pDC);
	LineWRTRect(x2,y1,x2,y2,pDC);
	LineWRTRect(x2,y2,x1,y2,pDC);
	LineWRTRect(x1,y2,x1,y1,pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CSimulateView printing

BOOL CSimulateView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CSimulateView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CSimulateView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CSimulateView diagnostics

#ifdef _DEBUG
void CSimulateView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CSimulateView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CSimulateDoc* CSimulateView::GetDocument() // non-debug version is InLine
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSimulateDoc)));
	return (CSimulateDoc*)m_pDocument;
}
#endif //_DEBUG

void CSimulateView::Zoom(int in_or_out)
{
  // in_or_out = 1  >> Zoom in
  // in_or_out = -1 >> Zoom out

  SIZE size = GetTotalSize();
  m_xZoomStep = size.cx / 10 ;
  m_yZoomStep = size.cy / 10 ;

  CClientDC ClientDC(this);
  OnPrepareDC(&ClientDC);
  ClientDC.LPtoDP(&size);
  CRect ScrollRect = CRect(0,0,size.cx,size.cy);
  CRect ClientArea ;
  GetClientRect(&ClientArea);

  int nMapMode ;
  SIZE SizeTotal , SizePage , SizeLine ;
 
  switch (in_or_out)
  {
  case 1 :
	  GetDeviceScrollSizes(nMapMode,SizeTotal,SizePage,SizeLine);
	  // zoom in unconditionally
	  //if (    ((m_DrawingSize.cx+m_xZoomStep)<=60000)
	  //	  ||  ((m_DrawingSize.cy+m_yZoomStep)<=60000)    )
	  {
	  m_DrawingSize.cx += m_xZoomStep ;
      m_DrawingSize.cy += m_yZoomStep ;
	  //m_DrawingSize.cx = min(m_DrawingSize.cx,65536);
	  //m_DrawingSize.cy = min(m_DrawingSize.cy,65536);
	  SetScrollSizes(MM_TEXT,m_DrawingSize);
      InvalidateRect(&ScrollRect);	  
	  }
	  break ;
  case -1 :
	  // Zoom out only if the drawing window dimensions are greater than the zooming step
	  if (    (m_DrawingSize.cx>=m_xZoomStep)  
           && (m_DrawingSize.cy>=m_yZoomStep)  )
	  { 
      // AND at least one of the dimensions of the drawing window smaller than the dimensions of the client area
		  if (    (ScrollRect.right>ClientArea.right) 
			   || (ScrollRect.bottom>ClientArea.bottom) )
		  {
		  if (ScrollRect.right>ClientArea.right ) m_DrawingSize.cx -= m_xZoomStep ;
          if (ScrollRect.bottom>ClientArea.bottom) m_DrawingSize.cy -= m_yZoomStep ;
		  SetScrollSizes(MM_TEXT,m_DrawingSize);
          InvalidateRect(&ScrollRect);	  
		  }
	  }
	  break ;
  }
  
  
}
/////////////////////////////////////////////////////////////////////////////
// CSimulateView message handlers


void CSimulateView::OnViewZoomIn() 
{
	// TODO: Add your command handler code here
	m_ZoomingRatio+=0.25;
	CClientDC ClientDC(this);
	SIZE sizeTotal;
	SIZE sizeLine;
	SIZE sizePage;
	int nMapMode;
	GetDeviceScrollSizes( nMapMode,sizeTotal,sizePage, sizeLine ) ;
	CBrush Brush;
	Brush.CreateSolidBrush(RGB(255,255,255));
	//ClientDC.FillRect(sizeTotal,&Brush);


	GetDocument()->UpdateAllViews(0);

//    Zoom(1); // Zoom in	
}

void CSimulateView::OnViewZoomOut() 
{
	// TODO: Add your command handler code here
	if (m_ZoomingRatio!=0.25)
		m_ZoomingRatio-=0.25;
	CClientDC ClientDC(this);
	//OnDraw(&ClientDC);
	GetDocument()->UpdateAllViews(NULL);

	//Zoom(-1); // Zoom out
}

void CSimulateView::OnUpdateSimulateContinue(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if ( m_SimulationStatus == Pause )
		pCmdUI->Enable(TRUE); // You can pause a simulation only when you are simulating
	else
		pCmdUI->Enable(FALSE);
}

void CSimulateView::OnUpdateSimulatePause(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
    if ( m_SimulationStatus == Simulating )
		pCmdUI->Enable(TRUE); // You can pause a simulation only when you are simulating
	else
		pCmdUI->Enable(FALSE);
}

void CSimulateView::OnUpdateSimulateStart(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if ( m_SimulationStatus == NotSimulating)
	   pCmdUI->Enable(TRUE); 
	else
	   pCmdUI->Enable(FALSE);
	
}  

void CSimulateView::OnUpdateSimulateStep(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if ( m_SimulationStatus == Simulating)
	   pCmdUI->Enable(FALSE); 
	else
	   pCmdUI->Enable(TRUE);
}

void CSimulateView::OnUpdateSimulateStop(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if ( m_SimulationStatus == NotSimulating )
		 pCmdUI->Enable(FALSE);
	else
		 pCmdUI->Enable(TRUE);
}

unsigned long CSimulateView::MOD(unsigned long Dividend ,
								 unsigned long Divisor )
{
  float fQuotient = (float) Dividend / Divisor ;
  unsigned long lQuotient = (unsigned long) fQuotient ;
  return ( Dividend - (Divisor*lQuotient) );
}


int CSimulateView::CheckNewCallArrival(unsigned long Start) 
{  // This function returns 1 if m_CurrentCall has just arrived
   //           and returns 0 if not
	int T = GetDocument()->GetT();
	float quotient = (float)Start/T ;
	unsigned long frame = (unsigned long)quotient ;
	int slot = Start - (frame*T) ;

	if (     (frame == m_CurrentFrame)
		&&   (slot  == m_CurrentSlot )    )
       return  1 ;
	else
	   return  0 ;
}
void CSimulateView::TerminateSimulation() 
{
	CString buffer ;
    if ( m_YesFile )
	      m_pFile->WriteString("Simulation terminated.\n");
    buffer.Format("Number of blocked calls = %u out of %u calls .",m_BlockNum,m_CallCount);
    if ( m_YesFile )
          m_pFile->WriteString((LPCTSTR)buffer);
   

	m_SimulationStatus = NotSimulating ;
	m_CurrentSlot = 0 ;
	m_CurrentFrame = 0 ;
	m_CallCount = 0 ;
	m_BlockNum = 0 ;
	m_MoreCalls = 1 ;
	m_NewCall = 0 ;
	CSimulateDoc* pDoc = GetDocument();
	pDoc->EnableMenuFlag(TRUE);	

	m_ValidCall = 0 ;
	m_pWinThread = 0 ;
	m_Threading = 0 ;
	
    m_YesFile = No ;
	strcpy(m_OutputFileSpec,"");
	m_FrameAndSlot = FALSE ;
	m_SrcAndDest = FALSE ;
	m_CMContents = NEVER ;
	if ( m_pFile->m_hFile != CFile::hFileNull )
		m_pFile->Close();	
}

// REDA **********************************************************************
// You should write here your own version of EndSimulation()
// that DEallocates memory .
//  In this function , YOU MUST CALL TerminateSimulation()
void CSimulateView::TST_EndSimulation()
{
int i,j;
TerminateSimulation() ;
return;
for(i=0;i<2;i++)
{
	for (j=0;j<m_S->m_N;j++)
		delete m_T[i][j];
		delete m_T[i];
}
delete m_S;
}


void CSimulateView::ST_EndSimulation()
{
    TerminateSimulation() ;
	int i = 0 ; // variables used in loops ;	
// Memory Deallocations of ST
	for ( i=0 ; i<GetDocument()->GetN() ; i++ )
		delete m_StTsi[i] ;
	delete [GetDocument()->GetN()] m_StTsi ;
	delete m_StGateSelect ;
	m_StTsi = NULL ;
	m_StGateSelect = NULL ;
}

void CSimulateView::TS_EndSimulation()
{
    TerminateSimulation() ;
	int i = 0 ; // variables used in loops ;	
// Memory Deallocations of ST
	for ( i=0 ; i<GetDocument()->GetN() ; i++ )
		delete m_TsTsi[i] ;
	delete [GetDocument()->GetN()] m_TsTsi ;
	delete m_TsGateSelect ;
	m_TsTsi = NULL ;
	m_TsGateSelect = NULL ;
}



int CSimulateView::TST_ServiceCall()
{
  int InLine  = m_CurrentCall.GetInputLine() ;
  int InSlot  = m_CurrentCall.GetInSlot() ;
  int OutLine = m_CurrentCall.GetOutputLine() ;
  int OutSlot = m_CurrentCall.GetOutSlot() ;
  unsigned long Duration = m_CurrentCall.GetDuration() ;
  if(m_T[1][OutLine]->m_control_array[OutSlot]!=NOT_USED)
	  return BUSY;
	else
	{
		if(m_T[0][InLine]->m_control_array[OutSlot]==NOT_USED)
			{
			m_T[0][InLine]->m_control_array[OutSlot]=InSlot;
			m_T[1][OutLine]->m_control_array[OutSlot]=OutSlot;
			m_S->m_gate_select_memory[InLine][OutSlot].outlet=OutLine;
			m_S->m_gate_select_memory[InLine][OutSlot].duration=Duration;

			UpdateTimeElementForAllViews(175,GR_UPPER+(GetDocument()->GetT()*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*InLine,0,InLine,OutSlot);
			UpdateTimeElementForAllViews(425,GR_UPPER+(GetDocument()->GetT()*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*OutLine,1,OutLine,OutSlot);

			return ESTABLISHED;
			}
		else
		{
		for (int j=0;j<m_S->m_M;j++)
			if(m_T[0][InLine]->m_control_array[j]==NOT_USED)
				{
				char outlet_not_available;
				outlet_not_available=FALSE;
				for (int k=0;k<m_S->m_N;k++)
					if (m_S->m_gate_select_memory[k][j].outlet==OutLine)
						outlet_not_available=TRUE;
				if(outlet_not_available==FALSE)
					{
					m_T[0][InLine]->m_control_array[j]=InSlot;
					m_T[1][OutLine]->m_control_array[OutSlot]=j;
					m_S->m_gate_select_memory[InLine][j].outlet=OutLine;
					m_S->m_gate_select_memory[InLine][j].duration=Duration;
					return ESTABLISHED;
					}
				}
		m_BlockNum++;
		return BLOCKED;
		}
	}
}



int CSimulateView::ST_ServiceCall()
{
  int InLine  = m_CurrentCall.GetInputLine() ;
  int InSlot  = m_CurrentCall.GetInSlot() ;
  int OutLine = m_CurrentCall.GetOutputLine() ;
  int OutSlot = m_CurrentCall.GetOutSlot() ;
  unsigned long Duration = m_CurrentCall.GetDuration() ;

  if ( m_StTsi[OutLine]->CheckBusyReceiver(OutSlot) )
     return ST_BUSY ;
  else
	  if ( m_StTsi[OutLine]->GetValue(InSlot)!=NOT_USED )
      {
	    m_BlockNum++;
	    return ST_BLOCKED ;
      }
      else
	  {
		m_StTsi[OutLine]->SetValue(InSlot,OutSlot);
		UpdateTimeElementForAllViews(425,GR_UPPER+(GetDocument()->GetT()*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*OutLine,1,OutLine,InSlot);
		m_StGateSelect->SetOutlet(InSlot,InLine,OutLine);
		m_StGateSelect->SetDuration(InSlot,InLine,Duration);
		return ST_NONBLOCKED ;
	  }
}

int CSimulateView::TS_ServiceCall()
{
  int InLine  = m_CurrentCall.GetInputLine() ;
  int InSlot  = m_CurrentCall.GetInSlot() ;
  int OutLine = m_CurrentCall.GetOutputLine() ;
  int OutSlot = m_CurrentCall.GetOutSlot() ;
  unsigned long Duration = m_CurrentCall.GetDuration() ;

  if ( m_TsGateSelect->CheckBusyReceiver(OutLine,OutSlot) )
     return ST_BUSY ;
  else
	  if ( m_TsTsi[InLine]->GetValue(OutSlot)!=NOT_USED )
      { 
	    m_BlockNum++ ;
	    return ST_BLOCKED ;
      }
      else
	  {
		m_TsTsi[InLine]->SetValue(OutSlot,InSlot);
		m_TsGateSelect->SetOutlet(OutSlot,OutLine,InLine);
		m_TsGateSelect->SetDuration(OutSlot,OutLine,Duration);
		UpdateTimeElementForAllViews(175,GR_UPPER+(GetDocument()->GetT()*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*InLine,0,InLine,OutSlot);
		return ST_NONBLOCKED ;
	  }
}


void CSimulateView::ST_UpdateGateSelect()
{
	int N = GetDocument()->GetN();
	int T = GetDocument()->GetT();
	for ( int i=0 ; i<N ; i++ )
	{
		if ( m_StGateSelect->GetOutlet(m_CurrentSlot,i) != NOT_USED )
	      {
          m_StGateSelect->SetDuration(m_CurrentSlot,i,
			         m_StGateSelect->GetDuration(m_CurrentSlot,i)-1);
		  if ( m_StGateSelect->GetDuration(m_CurrentSlot,i) == 0 )
		  {
			  int OutLine=m_StGateSelect->GetOutlet(m_CurrentSlot,i);
            m_StTsi[OutLine]->SetValue(m_CurrentSlot,NOT_USED);
			UpdateTimeElementForAllViews(425,GR_UPPER+(GetDocument()->GetT()*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*OutLine,1,OutLine,m_CurrentSlot);

            m_StGateSelect->SetOutlet(m_CurrentSlot,i,NOT_USED);
			m_StGateSelect->SetDuration(m_CurrentSlot,i,0);		  
			//UpdateGSElementForAllViews(20,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*N+40,i,m_CurrentSlot);
		  } // end if a call has finished		
		} // end if there is a call in the gate select
	} // end for


}

void CSimulateView::TS_UpdateGateSelect()
{
	int N = GetDocument()->GetN();
	int T = GetDocument()->GetT();
	for ( int i=0 ; i<N ; i++ )
	{
		if ( m_TsGateSelect->GetOutlet(m_CurrentSlot,i) != NOT_USED )
	      {
          m_TsGateSelect->SetDuration(m_CurrentSlot,i,
			         m_TsGateSelect->GetDuration(m_CurrentSlot,i)-1);
		  if ( m_TsGateSelect->GetDuration(m_CurrentSlot,i) == 0 )
		  {
			int OutLine=m_TsGateSelect->GetOutlet(m_CurrentSlot,i);
            m_TsTsi[OutLine]->SetValue(m_CurrentSlot,NOT_USED);
			UpdateTimeElementForAllViews(175,GR_UPPER+(GetDocument()->GetT()*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*OutLine,0,OutLine,m_CurrentSlot);
            m_TsGateSelect->SetOutlet(m_CurrentSlot,i,NOT_USED);
			m_TsGateSelect->SetDuration(m_CurrentSlot,i,0);		  
		  } // end if a call has finished		
		} // end if there is a call in the gate select
	} // end for
	//UpdateGSElementForAllViews(20,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*N+40,i,m_CurrentSlot);
}

void CSimulateView::TST_UpdateGateSelect()
{
	int N = GetDocument()->GetN();
	int T=  GetDocument()->GetT();
	for ( int i=0 ; i<N ; i++ )
	{
		if ( m_S->m_gate_select_memory[i][m_CurrentSlot].outlet != NOT_USED )
	      {
          m_S->m_gate_select_memory[i][m_CurrentSlot].duration-=1;
		  if ( m_S->m_gate_select_memory[i][m_CurrentSlot].duration <= 0 )
		  {
			for(int j=0;j<T;j++)
				if(m_T[1][m_S->m_gate_select_memory[i][m_CurrentSlot].outlet]->m_control_array[j]==m_CurrentSlot)
				{
				int OutLine=m_S->m_gate_select_memory[i][m_CurrentSlot].outlet;
				m_T[1][OutLine]->m_control_array[j]=NOT_USED;
				UpdateTimeElementForAllViews(425,GR_UPPER+(GetDocument()->GetT()*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*OutLine,1,OutLine,j /*outslot*/);
				j=T+100;		// exit outta this loop!
				}
			m_T[0][i]->m_control_array[m_CurrentSlot]=NOT_USED;

			UpdateTimeElementForAllViews(175,GR_UPPER+(GetDocument()->GetT()*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*i,0,i,m_CurrentSlot);


			m_S->m_gate_select_memory[i][m_CurrentSlot].outlet=NOT_USED;	// T	    to INLET x
			m_S->m_gate_select_memory[i][m_CurrentSlot].duration=0;
			
		  } // end if a call has finished		
		} // end if there is a call in the gate select
	//UpdateGSElementForAllViews(20,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*N+40,i,m_CurrentSlot);
	} // end for*/


}

void CSimulateView::ST_OutputGateSelect()
{
  int N = GetDocument()->GetN();
  int T = GetDocument()->GetT();
  CString buffer ;

  m_pFile->WriteString("      ");
  for ( int i=0 ; i<N ; i++ )
    {
	  buffer.Format("  %5d",i);
	  m_pFile->WriteString((LPCTSTR)buffer);
    }
  m_pFile->WriteString("\n");

  for ( int j=0 ; j<T ; j++ )
    {
      buffer.Format("%5d",j);
	  m_pFile->WriteString((LPCTSTR)buffer);
	  for ( i=0 ; i<N ; i++ )
	   {
		  buffer.Format(" %5d",m_StGateSelect->GetOutlet(j,i));
		  m_pFile->WriteString((LPCTSTR)buffer);
	   }
	  m_pFile->WriteString("\n");
    }
  m_pFile->WriteString("\n");  
}

void CSimulateView::TST_OutputGateSelect()
{
  int N = GetDocument()->GetN();
  int T = GetDocument()->GetT();
  CString buffer ;

  m_pFile->WriteString("      ");
  for ( int i=0 ; i<N ; i++ )
    {
	  buffer.Format("  %5d",i);
	  m_pFile->WriteString((LPCTSTR)buffer);
    }
  m_pFile->WriteString("\n");

  for ( int j=0 ; j<T ; j++ )
    {
      buffer.Format("%5d",j);
	  m_pFile->WriteString((LPCTSTR)buffer);
	  for ( i=0 ; i<N ; i++ )
	   {
		  buffer.Format(" %5d",m_S->m_gate_select_memory[i][j]);
		  m_pFile->WriteString((LPCTSTR)buffer);
	   }
	  m_pFile->WriteString("\n");
    }
  m_pFile->WriteString("\n");  
}

void CSimulateView::TS_OutputGateSelect()
{
  int N = GetDocument()->GetN();
  int T = GetDocument()->GetT();
  CString buffer ;

  m_pFile->WriteString("      ");
  for ( int i=0 ; i<N ; i++ )
    {
	  buffer.Format("  %5d",i);
	  m_pFile->WriteString((LPCTSTR)buffer);
    }
  m_pFile->WriteString("\n");

  for ( int j=0 ; j<T ; j++ )
    {
      buffer.Format("%5d",j);
	  m_pFile->WriteString((LPCTSTR)buffer);
	  for ( i=0 ; i<N ; i++ )
	   {
		  buffer.Format(" %5d",m_TsGateSelect->GetOutlet(j,i));
		  m_pFile->WriteString((LPCTSTR)buffer);
	   }
	  m_pFile->WriteString("\n");
    }
  m_pFile->WriteString("\n");  
}

UINT SimulationThread(LPVOID pViewParam)
{
	CSimulateView* pView = (CSimulateView*)pViewParam ;
	CSimulateDoc* pDoc = pView->GetDocument();
	
	int line = 0;
	CString buffer ;
	unsigned long lSlotsInBetween ;
	   // stores the randomized number of slots between a call 
	   // and the suceeding one
	unsigned long PrevStart ;
	   // stores the start of the previous call
	int N = pDoc->GetN() ; // Get N from document class
	int T = pDoc->GetT() ; // Get T from document class
	float fTime ;  
	buffer.Format("No. of calls = %u\n",pDoc->GetNumCalls());
    if (pView->m_YesFile) 
		pView->m_pFile->WriteString((LPCTSTR)buffer);
	
	while ( (pView->m_SimulationStatus != NotSimulating) && pView->m_MoreCalls)
	{ 
   	 // CurrentTime=(float)(m_CurrentFrame+1)*125+(m_CurrentSlot+1)*125/T; 
	    // time in milliseconds
	 // fprintf(pfile,"T=%f mcrsec\n", time ) ;    
       if ( pView->CheckNewCallArrival((pView->m_CurrentCall).GetCallStart()) )
		 pView->m_NewCall = 1 ;
	   else
	     pView->m_NewCall = 0 ; 	     
// REDA ***********************************************************************
// Add code here that takes the information of m_CurrentCall , m_CurrentFrame....etc.
// to service the call .
// Write results to RESULTS FILE . For now , write in any file untill I provide
// you with the interface that specifies the file path and name..
	  switch ( pView->GetDocument()->GetTopology() )
	  {
	  case TS  : 
		  if (pView->m_NewCall)
		    if ( pView->m_ValidCall = !(pView->m_TsTsi[pView->m_CurrentCall.GetInputLine()]->CheckDuplicateTransmitter(
			                      				                        pView->m_CurrentCall.GetInSlot()) )  )
		      { // begin if not duplicate transmitter
		      if ( pView->m_YesFile && pView->m_FrameAndSlot) 
	              {
				   buffer.Format("Frame:%u ,Slot:%d.",pView->m_CurrentFrame,pView->m_CurrentSlot );
		           pView->m_pFile->WriteString((LPCTSTR)buffer);
				  }
              if ( pView->m_YesFile ) 
			    {
				  buffer.Format("A new call has arrived.\nCall no . %u .\n",pView->m_CallCount);
				  pView->m_pFile->WriteString((LPCTSTR)buffer);
			    }
			  if ( pView->m_YesFile && pView->m_SrcAndDest )
			    { 
				  buffer.Format("Line %d Slot %d wants to call Line %d Slot %d.\n",
				          pView->m_CurrentCall.GetInputLine(),
						  pView->m_CurrentCall.GetInSlot(),						  
						  pView->m_CurrentCall.GetOutputLine(),
						  pView->m_CurrentCall.GetOutSlot() );
				  pView->m_pFile->WriteString((LPCTSTR)buffer);
				}			  
			  if ( pView->m_YesFile )
			   {
				  fTime = (float)((pView->m_CurrentCall.GetDuration()))/(float)sampling_rate ;
				  buffer.Format("The call would last for %.2f sec.\n",fTime);
    		      pView->m_pFile->WriteString((LPCTSTR)buffer);
			   }
			   (pView->m_CallCount)++ ;
			   switch ( pView->TS_ServiceCall() )
			   { // Begin switch
			   case ST_BUSY :
        		   buffer.Format("The called party is busy.\n");
		     	   break;
			   case ST_BLOCKED :
                   buffer.Format("The call is blocked.\n");				
				   break;
               case ST_NONBLOCKED :
                   buffer.Format("The call is established.\n");
				   break;
			   } // end switch
			   if ( pView->m_YesFile )
			       pView->m_pFile->WriteString((LPCTSTR)buffer);				  
            //   TS_ShowResults()   ;
		      } // end if not duplicate transmitter
          pView->TS_UpdateGateSelect() ;		
          if ( pView->m_YesFile )
	        switch ( pView->m_CMContents )
			 {
			 case FRAME :
                if ( pView->m_CurrentSlot == 0 )
				  pView->TS_OutputGateSelect();
				break ;
			 case SECOND :
                if ( pView->m_CurrentSlot == 0 ) 
				  if ( pView->MOD(pView->m_CurrentFrame,sampling_rate) == 0 )
				    pView->TS_OutputGateSelect();                
				break ;
			 case MINUTE :
				if ( pView->m_CurrentSlot == 0 )
                  if ( pView->MOD(pView->m_CurrentFrame,sampling_rate*60) == 0 )
				    pView->TS_OutputGateSelect();                
				break ;
			 case NEVER :
				break ;
			 }
		  break ;
	  case TST : 
			if (pView->m_NewCall)
				if ( pView->m_ValidCall = !(pView->m_S->CheckDuplicateTransmitter(
			                      pView->m_CurrentCall.GetInputLine() ,
							      pView->m_CurrentCall.GetInSlot()       ) )  )
				{	// begin if not duplicate transmitter

					if ( pView->m_YesFile && pView->m_FrameAndSlot) 
	              {
				   buffer.Format("Frame:%u ,Slot:%d.",pView->m_CurrentFrame,pView->m_CurrentSlot );
		           pView->m_pFile->WriteString((LPCTSTR)buffer);
				  }
              if ( pView->m_YesFile ) 
			    {
				  buffer.Format("A new call has arrived.\nCall no . %u .\n",pView->m_CallCount);
				  pView->m_pFile->WriteString((LPCTSTR)buffer);
			    }
			  if ( pView->m_YesFile && pView->m_SrcAndDest )
			    { 
				  buffer.Format("Line %d Slot %d wants to call Line %d Slot %d.\n",
				          pView->m_CurrentCall.GetInputLine(),
						  pView->m_CurrentCall.GetInSlot(),						  
						  pView->m_CurrentCall.GetOutputLine(),
						  pView->m_CurrentCall.GetOutSlot() );
				  pView->m_pFile->WriteString((LPCTSTR)buffer);
				}			  
			  if ( pView->m_YesFile )
			   {
				  fTime = (float)((pView->m_CurrentCall.GetDuration()))/(float)sampling_rate ;
				  buffer.Format("The call would last for %.2f sec.\n",fTime);
    		      pView->m_pFile->WriteString((LPCTSTR)buffer);
			   }


				(pView->m_CallCount)++ ;
				
//				pView->m_T[0][0]->DrawTime(1,1,pView);
					/*CClientDC ClientDC(pView);
				ClientDC.MoveTo(0,0);
				ClientDC.LineTo(100,100);*/

//					pView->m_CallCount=pDoc->GetNumCalls()+43;
			
		
			switch ( pView->TST_ServiceCall() )
			   { // Begin switch
			   case BUSY :
        		   buffer.Format("The called party is busy.\n");
				   //AfxMessageBox("Busy");
		     	   break;
			   case BLOCKED :
                   buffer.Format("The call is blocked.\n");				
				   //AfxMessageBox("Blocked");
				   break;
               case ESTABLISHED:
                   buffer.Format("The call is established.\n");
				   //AfxMessageBox("Established");
				   break;
			   case UNDEFINED:
				   //AfxMessageBox("Ya ahlan wasahlan");
				   break;
			   } // end switch
			   if ( pView->m_YesFile )
			       pView->m_pFile->WriteString((LPCTSTR)buffer);				  

				}			
		  pView->TST_UpdateGateSelect() ;
		  if ( pView->m_YesFile )
	        switch ( pView->m_CMContents )
			 {
			 case FRAME :
                if ( pView->m_CurrentSlot == 0 )
				  pView->TST_OutputGateSelect();

				break ;
			 case SECOND :
                if ( pView->m_CurrentSlot == 0 ) 
				  if ( pView->MOD(pView->m_CurrentFrame,sampling_rate) == 0 )
				    pView->TST_OutputGateSelect();                
				break ;
			 case MINUTE :
				if ( pView->m_CurrentSlot == 0 )
                  if ( pView->MOD(pView->m_CurrentFrame,sampling_rate*60) == 0 )
				    pView->TST_OutputGateSelect();                
				break ;
			 case NEVER :
				break ;
			 }
		  break ;
	  case ST  :
		  if (pView->m_NewCall)
		    if ( pView->m_ValidCall = !(pView->m_StGateSelect->CheckDuplicateTransmitter(
			                      pView->m_CurrentCall.GetInputLine() ,
							      pView->m_CurrentCall.GetInSlot()       ) )  )
		      { // begin if not duplicate transmitter
		      if ( pView->m_YesFile && pView->m_FrameAndSlot) 
	              {
				   buffer.Format("Frame:%u ,Slot:%d.",pView->m_CurrentFrame,pView->m_CurrentSlot );
		           pView->m_pFile->WriteString((LPCTSTR)buffer);
				  }
              if ( pView->m_YesFile ) 
			    {
				  buffer.Format("A new call has arrived.\nCall no . %u .\n",pView->m_CallCount);
				  pView->m_pFile->WriteString((LPCTSTR)buffer);
			    }
			  if ( pView->m_YesFile && pView->m_SrcAndDest )
			    { 
				  buffer.Format("Line %d Slot %d wants to call Line %d Slot %d.\n",
				          pView->m_CurrentCall.GetInputLine(),
						  pView->m_CurrentCall.GetInSlot(),						  
						  pView->m_CurrentCall.GetOutputLine(),
						  pView->m_CurrentCall.GetOutSlot() );
				  pView->m_pFile->WriteString((LPCTSTR)buffer);
				}			  
			  if ( pView->m_YesFile )
			   {
				  fTime = (float)((pView->m_CurrentCall.GetDuration()))/(float)sampling_rate ;
				  buffer.Format("The call would last for %.2f sec.\n",fTime);
    		      pView->m_pFile->WriteString((LPCTSTR)buffer);
			   }
			   (pView->m_CallCount)++ ;
			   switch ( pView->ST_ServiceCall() )
			   { // Begin switch
			   case ST_BUSY :
        		   buffer.Format("The called party is busy.\n");
		     	   break;
			   case ST_BLOCKED :
                   buffer.Format("The call is blocked.\n");				
				   break;
               case ST_NONBLOCKED :
                   buffer.Format("The call is established.\n");
				   break;
			   } // end switch
			   if ( pView->m_YesFile )
			       pView->m_pFile->WriteString((LPCTSTR)buffer);				  
            //   ST_ShowResults()   ;
		      } // end if not duplicate transmitter
          pView->ST_UpdateGateSelect() ;		
          if ( pView->m_YesFile )
	        switch ( pView->m_CMContents )
			 {
			 case FRAME :
                if ( pView->m_CurrentSlot == 0 )
				  pView->ST_OutputGateSelect();
				break ;
			 case SECOND :
                if ( pView->m_CurrentSlot == 0 ) 
				  if ( pView->MOD(pView->m_CurrentFrame,sampling_rate) == 0 )
				    pView->ST_OutputGateSelect();                
				break ;
			 case MINUTE :
				if ( pView->m_CurrentSlot == 0 )
                  if ( pView->MOD(pView->m_CurrentFrame,sampling_rate*60) == 0 )
				    pView->ST_OutputGateSelect();                
				break ;
			 case NEVER :
				break ;
			 }     
		  break ;
	  }

	  if ( pView->m_CurrentSlot == 0 )
              if ( pView->MOD(pView->m_CurrentFrame,sampling_rate*60) == 0 )
					pView->DrawGS(25,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*N+60);
	 
	  if (   (pView->m_CallCount>=pDoc->GetNumCalls())
		 || ((pView->m_CurrentCall.GetCallStart()) > (pView->GetDocument()->GetT() * sampling_rate * simulation_time_sec)))
	           pView->m_MoreCalls = 0 ;
	 if ( pView->m_NewCall )
	 {
		 PrevStart = (pView->m_CurrentCall).GetCallStart() ;
		 lSlotsInBetween = pDoc->RandomizeNewCall(pView->m_CurrentCall);		 
		 if (pView->m_ValidCall)
		 {
		    pView->m_CurrentCall.SetStart( PrevStart + lSlotsInBetween ) ;	
			pView->m_ValidCall = 0 ;
		 }
		 else
			pView->m_CurrentCall.SetStart( ++PrevStart );
	 }
	 pView->m_CurrentSlot = (pView->m_CurrentSlot+1) % pView->GetDocument()->GetT() ;
	 if ( pView->m_CurrentSlot == 0 )
		     pView->m_CurrentFrame++ ;	
	 }
   
// REDA ***********************************************************************
// Call your memory DEallocation function , because after the simulation has
// finished , the user is now able to chaenge N,T,type....etc. and then
// start a new simulation .
   switch(pView->GetDocument()->GetTopology())
   {
   case TS  : 
	   pView->TS_EndSimulation();
	   break ;
   case TST :  pView->TST_EndSimulation();
	   break ;
   case ST  :
	   pView->ST_EndSimulation();
	   break ;
   default  : break ;
   }
   pView->m_Threading = 0 ;  
   pView->m_SimulationStatus = NotSimulating ;  
   return 0 ; 
}

void CSimulateView::PrepareFirstCall() 
{
	m_BlockNum = 0 ;
    if ( m_YesFile == Yes )
		if ( !m_pFile->Open(m_OutputFileSpec,
		    CFile::modeCreate | CFile::modeWrite | CFile::typeText) )
	           {
		         AfxMessageBox("Failed to create results file.");
				 m_YesFile = No ;
	           }
	 ;
	int i ;
    CSimulateDoc* pDoc = GetDocument() ;
	pDoc->EnableMenuFlag(FALSE);
	int N = pDoc->GetN() ; // Get N from document class
	int T = pDoc->GetT() ; // Get T from document class
// REDA **********************************************************************
// Add code here for your memory allocation
// This function is called from ONLY TWO possible locations
// 1.the function that starts simulation (OnSimualteStart)
// 2.the function that steps into simulation(OnSimulateStep) , only if it
//    is now the first call . See below .
	switch ( pDoc->GetTopology() )
	{
	case TS  : 
	 if (m_TsTsi == NULL)
	 {
       m_TsTsi = new CTS_TSI* [N];
	   for(i=0;i<N;i++)
		   m_TsTsi[i] = new CTS_TSI(T);
	 }
     if (m_TsGateSelect == NULL)
	   m_TsGateSelect = new CTS_GateSelect(T,N);
		break ;
	case TST : 
				int i,j;
				for(i=0;i<2;i++)
					{
					m_T[i]=(CTimeSwitching **) new CTimeSwitching * [N];
					for (j=0;j<N;j++)
						
						m_T[i][j]=new CTimeSwitching(T);
						//char buff[10];
						//sprintf(buff,"%i",j);
						//if (i==0) m_T[i][j]->Create(buff,WS_VISIBLE|WS_CHILD|BS_DEFPUSHBUTTON ,CRect(75,25+j*90,125,95+j*90),this,10000);
						//else m_T[i][j]->Create(buff,WS_VISIBLE|WS_CHILD|BS_DEFPUSHBUTTON ,CRect(325,25+j*90,375,95+j*90),this,10000);
						
					}
				m_S=new CSpace(N,T);
				//m_S->Create("",WS_DISABLED|WS_VISIBLE|WS_CHILD|BS_DEFPUSHBUTTON ,CRect(175,25+0*90,275,95+T*90),this,10000);*/
			break ;
	case ST :  
// Memory Allocation is best made just before Simulation starts
     if (m_StTsi == NULL)
	 {
       m_StTsi = new CST_TSI* [N];
	   for(i=0;i<N;i++)
		   m_StTsi[i] = new CST_TSI(T);
	 }
     if (m_StGateSelect == NULL)
	   m_StGateSelect = new CST_GateSelect(T,N);	  
     break ;
	}

	m_CurrentSlot = 0 ;
	m_CurrentFrame = 0 ;
	m_CallCount = 0 ;
	m_MoreCalls = 1 ;
	m_ValidCall = 0 ;
	
	//float CurrentTime ;
	srand(GetDocument()->GetSeed());
	// Randomize the FIRST CALL
	pDoc->RandomizeNewCall(m_CurrentCall);	
	m_CurrentCall.SetStart(0); // the FIRST call arrives at slot no. 0
}

void CSimulateView::OnSimulateStart() 
{
 // TODO: Add your command handler code here	
/*
	int N=GetDocument()->GetN();
	int T=GetDocument()->GetT();
	int i,j;
	for(i=0;i<2;i++)
		{
		for (j=0;j<N;j++)
			{
			if (i==0) 
				DrawTime(75,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*j,i,j);
			else
				DrawTime(325,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*j,i,j);
				
			//	m_T[i][j]->Create(buff,WS_VISIBLE|WS_CHILD|BS_DEFPUSHBUTTON ,CRect(,125,95+j*90),this,10000);
			//else m_T[i][j]->Create(buff,WS_VISIBLE|WS_CHILD|BS_DEFPUSHBUTTON ,CRect(325,25+j*90,375,95+j*90),this,10000);
			}
				}
			DrawSpace(175,GR_UPPER);*/
			//m_S=new CSpace(N,T);
			//m_S->Create("",WS_DISABLED|WS_VISIBLE|WS_CHILD|BS_DEFPUSHBUTTON ,CRect(175,25+0*90,275,95+T*90),this,10000);*/
	
   m_SimulationStatus = Simulating ;	
   PrepareFirstCall();
   m_Threading = 1 ;  
   m_pWinThread = AfxBeginThread(SimulationThread,this,THREAD_PRIORITY_HIGHEST);    
}

void CSimulateView::OnSimulatePause() 
{
	// TODO: Add your command handler code here
	m_SimulationStatus = Pause ;
	m_pWinThread->SuspendThread();  
// If Pause is enabled , then we are sure that the thread is still running
}

void CSimulateView::OnSimulateContinue() 
{
	// TODO: Add your command handler code here
    m_SimulationStatus = Simulating ;
	if (m_Threading == 1 )
	  m_pWinThread->ResumeThread() ; 
	   // resume the thread that has been suspended
	else 
 	{
		m_Threading = 1 ;
		m_pWinThread = AfxBeginThread(SimulationThread,this,THREAD_PRIORITY_HIGHEST);    
	}
	     // If the user has begun the simulation session by choosing
	     // "Step" not Start , then a thread should begin right now
}

void CSimulateView::WriteFrameInfo(void)
{

}

void CSimulateView::OnSimulateStop() 
{
// TODO: Add your command handler code here
// REDA *******************************************************************
// Call here the function that DEallocates memory
if ( m_SimulationStatus == Pause )
 switch(GetDocument()->GetTopology())
   {
   case TS  : 
	    TS_EndSimulation();
	    break ;
   case TST : 
		TST_EndSimulation();
		break ;
   case ST  :
	    ST_EndSimulation();
	   break ;
   default  : break ;
   }
 else
   m_SimulationStatus = NotSimulating ;
}

void CSimulateView::OnSimulateStep() 
{	// TODO: Add your command handler code here
	// Stepping means simulating an ONLY ONE slot 
	//   m_SimulationStatus = Pause
		CString buffer ;
	CSimulateDoc* pDoc = GetDocument() ;
	unsigned long lSlotsInBetween , PrevStart ;
	float fTime ;  
  //if ( (m_CurrentFrame==0) && (m_CurrentSlot==0) )   // if it is the first call 
  //  if ( m_CallCount == 0 )
    if ( m_SimulationStatus == NotSimulating )
	   PrepareFirstCall() ;
	else
	 if ( m_MoreCalls )  // i.e. if there are still more calls to simulate
	   {
/////////////////////////////////////////////////////////////////////////////
	   if ( CheckNewCallArrival(m_CurrentCall.GetCallStart()) )
		 m_NewCall = 1 ;
	   else
	     m_NewCall = 0 ; 	     
// REDA ***********************************************************************
// Add code here that takes the information of m_CurrentCall , m_CurrentFrame....etc.
// to service the call .
// Write results to RESULTS FILE . For now , write in any file until I provide
// you with the interface that specifies the file path and name..
	  switch ( GetDocument()->GetTopology() )
	  {
	  case TS  :
		  if (m_NewCall)
		    if ( m_ValidCall = !(m_TsTsi[m_CurrentCall.GetInputLine()]->CheckDuplicateTransmitter(
			                      				             m_CurrentCall.GetInSlot()) )  )
		      { // begin if not duplicate transmitter
		      if ( m_YesFile && m_FrameAndSlot) 
	              {
				   buffer.Format("Frame:%u ,Slot:%d.",m_CurrentFrame,m_CurrentSlot );
		           m_pFile->WriteString((LPCTSTR)buffer);
				  }
              if ( m_YesFile ) 
			    {
				  buffer.Format("A new call has arrived.\nCall no . %u .\n",m_CallCount);
				  m_pFile->WriteString((LPCTSTR)buffer);
			    }
			  if ( m_YesFile && m_SrcAndDest )
			    { 
				  buffer.Format("Line %d Slot %d wants to call Line %d Slot %d.\n",
				          m_CurrentCall.GetInputLine(),
						  m_CurrentCall.GetInSlot(),						  
						  m_CurrentCall.GetOutputLine(),
						  m_CurrentCall.GetOutSlot() );
				  m_pFile->WriteString((LPCTSTR)buffer);
				}			  
			  if ( m_YesFile )
			   {
				  fTime = (float)((m_CurrentCall.GetDuration()))/(float)sampling_rate ;
				  buffer.Format("The call would last for %.2f sec.\n",fTime);
    		      m_pFile->WriteString((LPCTSTR)buffer);
			   }
			   m_CallCount++ ;
			   switch ( TS_ServiceCall() )
			   { // Begin switch
			   case ST_BUSY :
        		   buffer.Format("The called party is busy.\n");
		     	   break;
			   case ST_BLOCKED :
                   buffer.Format("The call is blocked.\n");				
				   break;
               case ST_NONBLOCKED :
                   buffer.Format("The call is established.\n");
				   break;
			   } // end switch
			   if ( m_YesFile )
			       m_pFile->WriteString((LPCTSTR)buffer);				  
            //   TS_ShowResults()   ;
		      } // end if not duplicate transmitter
          TS_UpdateGateSelect() ;		
          if ( m_YesFile )
	        switch ( m_CMContents )
			 {
			 case FRAME :
                if ( m_CurrentSlot == 0 )
				   TS_OutputGateSelect();
				break ;
			 case SECOND :
                if ( m_CurrentSlot == 0 ) 
				 if ( MOD(m_CurrentFrame,sampling_rate) == 0 )
				   TS_OutputGateSelect();                
				break ;
			 case MINUTE :
				if ( m_CurrentSlot == 0 )
                 if ( MOD(m_CurrentFrame,sampling_rate*60) == 0 )
				   TS_OutputGateSelect();                
				break ;
			 case NEVER :
				break ;
			 }
		  break ;
	  case TST : 
		  	if (m_NewCall)
				if ( m_ValidCall = !(m_S->CheckDuplicateTransmitter(
			                      m_CurrentCall.GetInputLine() ,
							      m_CurrentCall.GetInSlot()       ) )  )
				{	// begin if not duplicate transmitter

					if ( m_YesFile && m_FrameAndSlot) 
	              {
				   buffer.Format("Frame:%u ,Slot:%d.",m_CurrentFrame,m_CurrentSlot );
		           m_pFile->WriteString((LPCTSTR)buffer);
				  }
              if ( m_YesFile ) 
			    {
				  buffer.Format("A new call has arrived.\nCall no . %u .\n",m_CallCount);
				  m_pFile->WriteString((LPCTSTR)buffer);
			    }
			  if ( m_YesFile && m_SrcAndDest )
			    { 
				  buffer.Format("Line %d Slot %d wants to call Line %d Slot %d.\n",
				          m_CurrentCall.GetInputLine(),
						  m_CurrentCall.GetInSlot(),						  
						  m_CurrentCall.GetOutputLine(),
						  m_CurrentCall.GetOutSlot() );
				  m_pFile->WriteString((LPCTSTR)buffer);
				}			  
			  if ( m_YesFile )
			   {
				  fTime = (float)((m_CurrentCall.GetDuration()))/(float)sampling_rate ;
				  buffer.Format("The call would last for %.2f sec.\n",fTime);
    		      m_pFile->WriteString((LPCTSTR)buffer);
			   }


				m_CallCount++ ;
				
//				m_T[0][0]->DrawTime(1,1,pView);
					/*CClientDC ClientDC(pView);
				ClientDC.MoveTo(0,0);
				ClientDC.LineTo(100,100);*/

			switch ( TST_ServiceCall() )
			   { // Begin switch
			   case BUSY :
        		   buffer.Format("The called party is busy.\n");
				   //AfxMessageBox("Busy");
		     	   break;
			   case BLOCKED :
                   buffer.Format("The call is blocked.\n");				
				   //AfxMessageBox("Blocked");
				   break;
               case ESTABLISHED:
                   buffer.Format("The call is established.\n");
				   //AfxMessageBox("Established");
				   break;
			   case UNDEFINED:
				   //AfxMessageBox("Ya ahlan wasahlan");
				   break;
			   } // end switch
			   if ( m_YesFile )
			       m_pFile->WriteString((LPCTSTR)buffer);				  

				}			
		  TST_UpdateGateSelect() ;
		  if ( m_YesFile )
	        switch ( m_CMContents )
			 {
			 case FRAME :
                if ( m_CurrentSlot == 0 )
				  TST_OutputGateSelect();
				break ;
			 case SECOND :
                if ( m_CurrentSlot == 0 ) 
				  if ( MOD(m_CurrentFrame,sampling_rate) == 0 )
				    TST_OutputGateSelect();                
				break ;
			 case MINUTE :
				if ( m_CurrentSlot == 0 )
                  if ( MOD(m_CurrentFrame,sampling_rate*60) == 0 )
				    TST_OutputGateSelect();                
				break ;
			 case NEVER :
				break ;
			 }
		  break ;
	  case ST  :
          if (m_NewCall)
		    if ( m_ValidCall = !(m_StGateSelect->CheckDuplicateTransmitter(
			                      m_CurrentCall.GetInputLine() ,
							      m_CurrentCall.GetInSlot()       ) )  )
		      { // begin if not duplicate transmitter
		      if ( m_YesFile && m_FrameAndSlot) 
	              {
				   buffer.Format("Frame:%u ,Slot:%d.",m_CurrentFrame,m_CurrentSlot );
		           m_pFile->WriteString((LPCTSTR)buffer);
				  }
              if ( m_YesFile ) 
			    {
				  buffer.Format("A new call has arrived.\nCall no . %u .\n",m_CallCount);
				  m_pFile->WriteString((LPCTSTR)buffer);
			    }
			  if ( m_YesFile && m_SrcAndDest )
			    { 
				  buffer.Format("Line %d Slot %d wants to call Line %d Slot %d.\n",
				          m_CurrentCall.GetInputLine(),
						  m_CurrentCall.GetInSlot(),						  
						  m_CurrentCall.GetOutputLine(),
						  m_CurrentCall.GetOutSlot() );
				  m_pFile->WriteString((LPCTSTR)buffer);
				}			  
			  if ( m_YesFile )
			   {
				  fTime = (float)((m_CurrentCall.GetDuration()))/(float)sampling_rate ;
				  buffer.Format("The call would last for %.2f sec.\n",fTime);
    		      m_pFile->WriteString((LPCTSTR)buffer);
			   }
			   m_CallCount++ ;
			   switch ( ST_ServiceCall() )
			   { // Begin switch
			   case ST_BUSY :
        		   buffer.Format("The called party is busy.\n");
		     	   break;
			   case ST_BLOCKED :
                   buffer.Format("The call is blocked.\n");				
				   break;
               case ST_NONBLOCKED :
                   buffer.Format("The call is established.\n");
				   break;
			   } // end switch
			   if ( m_YesFile )
			       m_pFile->WriteString((LPCTSTR)buffer);				  
            //   ST_ShowResults()   ;
		      } // end if not duplicate transmitter
          ST_UpdateGateSelect() ;		
          if ( m_YesFile )
	        switch ( m_CMContents )
			 {
			 case FRAME :
                if ( m_CurrentSlot == 0 )
				  ST_OutputGateSelect();
				break ;
			 case SECOND :
                if ( m_CurrentSlot == 0 ) 
				  if ( MOD(m_CurrentFrame,sampling_rate) == 0 )
				    ST_OutputGateSelect();                
				break ;
			 case MINUTE :
				if ( m_CurrentSlot == 0 )
                  if ( MOD(m_CurrentFrame,sampling_rate*60) == 0 )
				    ST_OutputGateSelect();                
				break ;
			 case NEVER :
				break ;
			 }
		  break ;
	  }
	 if (   (m_CallCount>=pDoc->GetNumCalls())
		 || ((m_CurrentCall.GetCallStart()) > (GetDocument()->GetT() * sampling_rate * simulation_time_sec)))
	           m_MoreCalls = 0 ;
	 if ( m_NewCall )
	 {
		 PrevStart = m_CurrentCall.GetCallStart() ;
		 lSlotsInBetween = pDoc->RandomizeNewCall(m_CurrentCall);		 
		 if (m_ValidCall)
		 {
		    m_CurrentCall.SetStart( PrevStart + lSlotsInBetween ) ;	
			m_ValidCall = 0 ;
		 }
		 else
			m_CurrentCall.SetStart( ++PrevStart );
	 }

	 m_CurrentSlot = (m_CurrentSlot+1) % GetDocument()->GetT() ;
	 if ( m_CurrentSlot == 0 )
		     m_CurrentFrame++ ;	
/////////////////////////////////////////////////////////////////////////////
	   } // end if m_MoreCalls
	  else
	   {
	     switch(GetDocument()->GetTopology())
         {
           case TS  : 
	         TS_EndSimulation();
	         break ;
           case TST : 
	         break ;
           case ST  :
	         ST_EndSimulation();
	         break ;
           default  : break ;
         }        
		 m_SimulationStatus = NotSimulating ;
	   }
	  int T=GetDocument()->GetT();
	  int N=GetDocument()->GetN();

	  	DrawGS(25,GR_UPPER+(T*GR_SLOT_HEIGHT+GR_GAP_HEIGHT)*N+60);
	  if ( m_MoreCalls )
	     m_SimulationStatus = Pause ;     	
}


////////////////////////////////////////////////////////////////

void CSimulateView::OnSize(UINT nType, int cx, int cy) 
{
	CScrollView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	CClientDC DC(this) ;
    OnPrepareDC(&DC);
	
	CSize size = GetTotalSize() ;
	CRect ScrollRect(0,0,size.cx,size.cy);
    DC.LPtoDP(&ScrollRect); // change to device coordinates
	                          // so as to compare with client area dimensions
	CRect ClientArea ;
	GetClientRect(&ClientArea);
	// If the drawing area is smaller than or equal to the drawing area ,
	// update m_DrawingSize 
	
	//if ( (ScrollRect.right<=ClientArea.right) && (ScrollRect.bottom<=ClientArea.bottom) )
	//{
	//  m_DrawingSize.cx = cx	;
	//  m_DrawingSize.cy = cy ;
    //}		

	if (ScrollRect.right<=cx)
		m_DrawingSize.cx = cx ;
    if (ScrollRect.bottom<=cy)
		m_DrawingSize.cy = cy ;
}	
	
void CSimulateView::OnSimulateResultsOptions() 
{
	// TODO: Add your command handler code here
	COptions dlg ;
	dlg.DoModal() ;
	
	m_YesFile = dlg.m_YesFile ;
	m_FrameAndSlot = dlg.m_FrameAndSlot ;
	m_SrcAndDest = dlg.m_SrcAndDest ;
	m_CMContents = dlg.m_CMContents ;
	strcpy(m_OutputFileSpec,(LPCTSTR)dlg.m_OutputFileSpec);
}

void CSimulateView::OnUpdateSimulateResultsOptions(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if ( m_SimulationStatus == NotSimulating )
		pCmdUI->Enable(TRUE) ;
	else
		pCmdUI->Enable(FALSE) ;
	
}

